﻿'*
'*  4dSystems製 uOLED-96-G1 のSDカード内のイメージ表示コマンドに対応できる様に
'*　イメージデータをセクタ(512byte)毎にイメージファイルを作成する
'*  ここでいうセクタは論理セクタ番号なのでマイコン側で物理セクタ番号に変換する
'*
'*  セクタ０
'*  0x0000( 16 ) "OLED_ICONS"            識別文字列 + 0x00 ...
'*  0x0010( 16 ) "2008/10/01"            作成年月日 + 0x00 ...
'*  0x0020(  1 ) カラーモード 8 / 16
'*
'*  セクタ１～４(256個分のアイコン情報）
'*  0x0000( 1) : インデックス番号
'*  0x0001( 1) : 0固定
'*  0x0002( 1) : Xサイズ
'*  0x0003( 1) : Yサイズ
'*  0x0004( 4) : アイコンデータセクタ番号
'*
'*  セクタ５～　アイコンデータ
'* 
Public Class fmIconMake

    '*  扱えるイメージの横／縦のドット数
    Private ReadOnly Xsize As Integer = 96
    Private ReadOnly Ysize As Integer = 64

    '*  ピクチャボックスグリッドの横／縦の数
    Private ReadOnly GridX As Integer = 8
    Private ReadOnly GridY As Integer = 32

    '*  クラス内ローカル変数
    Private iconDatas As Byte() = Nothing           '* ICON.DAT データ本体格納バッファ
    Private rightClick As PictureBox = Nothing      '* 右クリック時のピクチャボックスグリッドアイテム
    Private currentX As Integer = 0                 '* ピクチャボックスグリッド内のカーソル位置(X)
    Private currentY As Integer = 0                 '* ピクチャボックスグリッド内のカーソル位置(Y)

    '*************************************************************************
    '*  イベント
    '*                          フォームロード
    '*************************************************************************
    Private Sub fmIconMake_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '* ピクチャボックスグリッド作成
        functions.makePiclist(Me.Panel1, Me.GridX, Me.GridY, Me.Xsize + 12, Me.Ysize + 12, 11, 24)

        '*  テキストボックス設定
        Me.TextBox1.Top = Me.Panel1.Top
        Me.TextBox1.Left = Me.Panel1.Left
        Me.TextBox1.Width = Me.Panel1.Width
        Me.TextBox1.Height = Me.Panel1.Height

        '*  ドラックドロップイベント登録
        Me.SetEvents(Me.GroupBox1)
        Me.SetEvents(Me.Panel1)

        '*  ピクチャボックスグリッドへカーソル設定
        Me.getItemPic(Me.currentX, Me.currentY).BackColor = Color.Blue
        Me.PictureBox4.Image = CType(Me.Panel1.Controls(0), PictureBox).Image

    End Sub

    '*************************************************************************
    '*  イベント
    '*                          フォームクローズ
    '*************************************************************************
    Private Sub fmIconMake_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        End

    End Sub

    '*************************************************************************
    '*  イベント
    '*              メニュー「フォントファイル作成」クリック
    '*************************************************************************
    Private Sub FontToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FontToolStripMenuItem.Click
        fmFontMake.Top = Me.Top
        fmFontMake.Left = Me.Left
        fmFontMake.Show()
        Me.Hide()
    End Sub

    '*************************************************************************
    '*  イベント
    '*              メニュー「OGGプラグインファイル作成」クリック
    '*************************************************************************
    Private Sub OggToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OggToolStripMenuItem.Click
        fmOgg.Top = Me.Top
        fmOgg.Left = Me.Left
        fmOgg.Show()
        Me.Hide()
    End Sub

    '*************************************************************************
    '*  イベント
    '*              アイコンヘッダ表示ボタンクリック
    '*************************************************************************
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        Dim txt As String = ""
        txt &= "//" & vbCr & vbLf
        txt &= "// アイコン（イメージ）インデックスブロック定義" & vbCr & vbLf
        txt &= "// OLEDモジュール上のSDカード内にあるファイル ICON.DAT に適したデータが必要" & vbCr & vbLf
        txt &= "//" & vbCr & vbLf
        txt &= "static const prog_uint8_t iconIndexBlock[] = {" & vbCr & vbLf & vbTab

        '*  コントロール設定
        Me.Buttons_Enabled(False)

        '*  データ作成
        Me.makeIconDatas()

        For i As Integer = 0 To 2048 - 1
            If ((i > 0) AndAlso ((i Mod 32) = 0)) Then
                txt &= vbCr & vbLf & vbTab
            End If
            txt &= "0x" & Me.iconDatas(512 + i).ToString("x02") & ", "
        Next i
        txt &= vbCr & vbLf & "};" & vbCr & vbLf

        Me.TextBox1.Text = txt
        Me.TextBox1.Visible = True
        Me.TextBox1.Focus()

        Me.Panel1.Visible = False
        Me.Button5.Visible = True

    End Sub

    '*************************************************************************
    '*  イベント
    '*                             OKボタンクリック
    '*************************************************************************
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        '*  コントロール設定
        Me.Buttons_Enabled(True)
        Me.Panel1.Visible = True
        Me.Button1.Focus()

        Me.TextBox1.Visible = False
        Me.Button5.Visible = False

    End Sub

    '*************************************************************************
    '*  イベント
    '*              テキストボックスで Ctrl+A 
    '*************************************************************************
    Private Sub TextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown

        If ((e.Control = True) AndAlso (e.KeyCode = Keys.A)) Then
            Me.TextBox1.Select(0, Me.TextBox1.Text.Length)
        End If

    End Sub

    '*************************************************************************
    '*  イベント
    '*              ICON.DAT作成ボタンクリック
    '*************************************************************************
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        '*  コントロール無効
        Me.Buttons_Enabled(False)

        '*  データ作成
        Me.makeIconDatas()

        '*  データをファイルに書き込む
        Using d As New SaveFileDialog
            With d
                .FileName = "icon.dat"
                .Filter = "DATファイル(*.dat)|*.dat|すべてのファイル(*.*)|*.*"
                .Title = "アイコン保存先のファイルを選択してください"
                .RestoreDirectory = True
                If (.ShowDialog() = DialogResult.OK) Then
                    Application.DoEvents()
                    Dim bw As New System.IO.FileStream(.FileName, IO.FileMode.Create, IO.FileAccess.Write)
                    bw.Write(Me.iconDatas, 0, iconDatas.Length)
                    bw.Close()
                    bw.Dispose()
                    MessageBox.Show("アイコンファイルを作成しました", "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End If
            End With
        End Using

        '*  コントロール有効
        Me.Buttons_Enabled(True)

    End Sub

    '*************************************************************************
    '*  イベント
    '*                          ICON.DAT読み込みボタンクリック
    '*************************************************************************
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        Dim fname As String = ""

        Using d As New OpenFileDialog
            With d
                .Title = "OLED形式アイコンファイル選択"
                .Filter = "DATファイル(*.dat)|*.dat|すべてのファイル(*.*)|*.*"
                .FilterIndex = 0
                .FileName = "icon.dat"
                If (.ShowDialog() = DialogResult.OK) Then
                    If (Load_OledIconFile(.FileName) = False) Then
                        Me.RadioButton2.Checked = True
                        For i As Integer = 0 To 255
                            Dim pic As PictureBox = CType(Me.Panel1.Controls(i * 2), PictureBox)
                            If (Not pic.Image Is Nothing) Then
                                pic.Image.Dispose()
                                pic.Image = Nothing
                            End If
                        Next i
                    End If
                End If
            End With
        End Using

        Me.PictureBox4.Image = getItemPic(Me.currentX, Me.currentY).Image

    End Sub

    '*************************************************************************
    '*  イベント
    '*                    フォルダ内BMP一括読込みボタンクリック
    '*************************************************************************
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If (MessageBox.Show("現在ロードされているイメージは全てクリアされます。" & vbCr & "よろしいですか？", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.No) Then
            Return
        End If

        Using d As New FolderBrowserDialog
            d.Description = "img???.bmpファイルが入っているフォルダを指定して下さい"
            d.RootFolder = Environment.SpecialFolder.Desktop
            d.SelectedPath = Application.StartupPath
            If (d.ShowDialog() = DialogResult.OK) Then
                Me.Load_LoadImages(d.SelectedPath)
            End If
        End Using

        Me.PictureBox4.Image = getItemPic(Me.currentX, Me.currentY).Image

    End Sub

    '*************************************************************************
    '*  イベント
    '*              パネル内のピクチャボックスでマウスクリック
    '*************************************************************************
    Private Sub PictureBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)

        If (Me.Panel1.Controls.IndexOf(sender) >= 0) Then

            '*  現在のカーソル位置の背景を戻す
            getItemPic(Me.currentX, Me.currentY).BackColor = SystemColors.Control

            '*  クリックされたアイテムの背景を設定
            Dim pic As PictureBox = CType(sender, PictureBox)
            Me.PictureBox4.Image = pic.Image
            pic.BackColor = Color.Blue

            '*  現在のカーソル位置を記憶
            Me.currentX = getItemX(pic)
            Me.currentY = getItemY(pic)

            If (e.Button = Windows.Forms.MouseButtons.Right) Then
                Me.rightClick = sender
            End If

        End If

    End Sub

    '*************************************************************************
    '*  イベント
    '*     ピクチャボックスグリッドのコンテキストメニュー「イメージの削除」
    '*************************************************************************
    Private Sub ToolStripMenuItem_RemoveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem_RemoveImage.Click

        If (Not Me.rightClick.Image Is Nothing) Then
            Me.rightClick.Image.Dispose()
            Me.PictureBox4.Image = Nothing
        End If
        Me.rightClick.Image = Nothing

    End Sub

    '*************************************************************************
    '*  イベント
    '*              ピクチャボックスグリッドのドラック開始
    '*************************************************************************
    Private Sub PictureBox_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)

        Dim pic As PictureBox = CType(sender, PictureBox)
        If (Not pic.Image Is Nothing) Then
            If (e.Button = Windows.Forms.MouseButtons.Left) Then
                pic.DoDragDrop(New DataObject(DataFormats.Bitmap, pic.Image), DragDropEffects.All)
            End If
        End If

    End Sub

    '*************************************************************************
    '*  イベント
    '*          ピクチャボックスグリッドへドロップができるかチェック
    '*************************************************************************
    Private Sub PictureBox_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)

        Dim bmp As Bitmap = Nothing
        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            Dim fnames() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
            If (fnames.Length = 1) Then
                bmp = New Bitmap(fnames(0))
            End If
        ElseIf (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            bmp = CType(e.Data.GetData(DataFormats.Bitmap), Bitmap)
        End If

        e.Effect = DragDropEffects.None
        If (Not bmp Is Nothing) Then
            If ((bmp.Width >= 1) AndAlso (bmp.Width <= Me.Xsize) OrElse (bmp.Height >= 1) AndAlso (bmp.Height <= Me.Ysize)) Then
                e.Effect = DragDropEffects.Copy
            End If
        End If

    End Sub

    '*************************************************************************
    '*  イベント
    '*              ピクチャボックスグリッドへドロップ
    '*************************************************************************
    Private Sub PictureBox_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)

        Dim pic As PictureBox = CType(sender, PictureBox)
        Dim bmp As Bitmap = Nothing

        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            Dim fnames() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
            If (fnames.Length = 1) Then
                Dim img As Bitmap = Nothing
                Try
                    img = New Bitmap(fnames(0))
                    bmp = New Bitmap(img.Width, img.Height, Imaging.PixelFormat.Format24bppRgb)

                    Using g As Graphics = Graphics.FromImage(bmp)
                        g.FillRectangle(Brushes.White, New RectangleF(0, 0, bmp.Width, bmp.Height))
                    End Using

                    For y As Integer = 0 To bmp.Height - 1
                        For x As Integer = 0 To bmp.Width - 1
                            bmp.SetPixel(x, y, img.GetPixel(x, y))
                        Next x
                    Next y

                    img.Dispose()
                    img = Nothing

                Catch ex As Exception
                    If (Not bmp Is Nothing) Then
                        bmp.Dispose()
                        bmp = Nothing
                    End If

                    If (Not img Is Nothing) Then
                        img.Dispose()
                        img = Nothing
                    End If

                End Try

            End If

        ElseIf (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            bmp = CType(e.Data.GetData(DataFormats.Bitmap), Bitmap).Clone
        End If

        If (Not pic.Image Is Nothing) Then
            pic.Image.Dispose()
        End If
        pic.Image = bmp

        If (Me.Panel1.Controls.IndexOf(sender) >= 0) Then

            '*  現在のカーソル位置の背景を戻す
            getItemPic(Me.currentX, Me.currentY).BackColor = SystemColors.Control

            '*  クリックされたアイテムの背景を設定
            pic = CType(sender, PictureBox)
            Me.PictureBox4.Image = pic.Image
            pic.BackColor = Color.Blue

            '*  現在のカーソル位置を記憶
            Me.currentX = getItemX(pic)
            Me.currentY = getItemY(pic)

        End If

    End Sub

    '*************************************************************************
    '*  メソッド
    '*                      ピクチャボックスグリッドへイベントを登録
    '*  引数：Object c コンテナ
    '*  戻値：void
    '*************************************************************************
    Private Sub SetEvents(ByVal c As Object)

        With c
            For i As Integer = 0 To .Controls.Count - 1
                Dim obj As Object = .Controls.Item(i)
                If (obj.GetType Is GetType(PictureBox)) Then
                    Dim pic As PictureBox = CType(obj, PictureBox)
                    pic.AllowDrop = True
                    pic.SizeMode = PictureBoxSizeMode.CenterImage
                    pic.ContextMenuStrip = Me.ContextMenuStrip1
                    AddHandler pic.MouseMove, AddressOf Me.PictureBox_MouseMove
                    AddHandler pic.DragEnter, AddressOf Me.PictureBox_DragEnter
                    AddHandler pic.DragDrop, AddressOf Me.PictureBox_DragDrop
                    AddHandler pic.MouseDown, AddressOf Me.PictureBox_MouseDown
                End If
            Next i
        End With
    End Sub

    '*************************************************************************
    '*  メソッド
    '*      指定のピクチャボックスに登録されているイメージをOLED形式に変換
    '*  引数：void
    '*  戻値：void
    '*************************************************************************
    Private Function Convert(ByVal pic As PictureBox, ByRef secIndex As Integer, ByVal data As Byte()) As Integer

        If (pic.Image Is Nothing) Then
            Return (0)
        End If

        '*  8ビットモード/16ビットモード確認
        Dim cd As Integer = 1
        If (Me.RadioButton2.Checked = True) Then
            cd = 2
        End If

        '*  ビットマップ情報取得
        Dim bmp As Bitmap = CType(pic.Image, Bitmap)
        Dim imageBytes As Integer = bmp.Width * bmp.Height * cd
        Dim secCount As Integer = (imageBytes + 511) \ 512

        '*  データ変換
        If (Not data Is Nothing) Then
            If (secCount > 0) Then
                Dim pos As Integer = secIndex * 512
                For y As Integer = 0 To bmp.Height - 1
                    For x As Integer = 0 To bmp.Width - 1
                        If (cd = 1) Then
                            data(pos) = ColorToRGB8(bmp.GetPixel(x, y))
                            pos += 1
                        Else
                            Dim c As UShort = ColorToRGB16(bmp.GetPixel(x, y))
                            data(pos + 0) = CType(((c And &HFF00) >> 8), Byte)
                            data(pos + 1) = CType((c And &HFF), Byte)
                            pos += 2
                        End If
                    Next x
                Next y
            End If
        End If

        '*  セクタインデックス書き換え
        secIndex += secCount
        Return (secCount)

    End Function

    '*************************************************************************
    '*  メソッド
    '*                  各ボタンコントロールの有効／無効設定
    '*  引数：Boolean Enabled True:有効  False:無効
    '*  戻値：void
    '*************************************************************************
    Private Sub Buttons_Enabled(ByVal Enabled As Boolean)

        Me.Button1.Enabled = Enabled
        Me.Button2.Enabled = Enabled
        Me.Button3.Enabled = Enabled
        Me.Button4.Enabled = Enabled
        Me.Panel1.Enabled = Enabled
        Me.GroupBox1.Enabled = Enabled
        Me.GroupBox3.Enabled = Enabled
        Me.FileToolStripMenuItem.Enabled = Enabled

    End Sub

    '*************************************************************************
    '*  メソッド
    '*                指定のOLED形式アイコンファイルを読み込む
    '*  引数：String  fname ファイル名
    '*  戻値：Boolean True/成功  False/失敗
    '*************************************************************************
    Private Function Load_OledIconFile(ByVal fname As String)

        Dim fs As System.IO.FileStream = Nothing
        Dim data As Byte() = Nothing

        '*  アイコンファイルを読み込む
        Try
            fs = New System.IO.FileStream(fname, IO.FileMode.Open, IO.FileAccess.Read)
            If (fs.Length < (512 * 5)) Then
                MessageBox.Show("ヘッダサイズ分のファイルサイズがありません", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If

            ReDim data(fs.Length)
            fs.Read(data, 0, fs.Length)
            fs.Close()
            fs.Dispose()
            fs = Nothing

        Catch ex As Exception
            MessageBox.Show(fname & "を読み込めません", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        End Try

        '*  ヘッダ認識
        Dim h1 As String = System.Text.Encoding.GetEncoding(932).GetString(data, 0, 10)
        Dim h2 As String = System.Text.Encoding.GetEncoding(932).GetString(data, &H10, 10)
        If (h1 <> "OLED_ICONS") Then
            MessageBox.Show("識別子エラーです", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        End If

        If (IsDate(h2) = False) Then
            MessageBox.Show("日付エラーです", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        End If

        Dim col As Byte = data(&H20)
        If ((col <> 8) AndAlso (col <> 16)) Then
            MessageBox.Show("サポートしない色モードです", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        End If

        '*  アイコン毎の読込み
        For i As Integer = 0 To 255

            '*  アイコン情報ブロック認識
            Dim headFpos As Integer = 512 + (i * 8)
            Dim idx As Integer = CType(data(headFpos + 0), Integer)
            Dim zero As Integer = CType(data(headFpos + 1), Integer)
            Dim xs As Integer = CType(data(headFpos + 2), Integer)
            Dim ys As Integer = CType(data(headFpos + 3), Integer)
            Dim secIndex As UInt32 = CType(data(headFpos + 4), UInt32) + (CType(data(headFpos + 5), UInt32) << 8) + (CType(data(headFpos + 6), UInt32) << 16) + (CType(data(headFpos + 7), UInt32) << 24)

            If (idx <> i) Then
                MessageBox.Show("インデックス番号が一致しません", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If

            If (zero <> 0) Then
                MessageBox.Show("サポートしないデータです", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If

            If ((xs > Me.Xsize) OrElse (ys > Me.Ysize)) Then
                MessageBox.Show("イメージサイズがサポート外です", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If

            Dim imgByte = (col / 8) * xs * ys
            Dim imgFpos = secIndex * 512
            If ((imgFpos + imgByte - 1) > data.Length) Then
                MessageBox.Show("セクタ番号がオーバーフローしました", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If

            Dim pic As PictureBox = CType(Me.Panel1.Controls(i * 2), PictureBox)

            '*  アイコンデータをビットマップに変換
            If ((xs = 0) OrElse (ys = 0)) Then
                If (Not pic.Image Is Nothing) Then
                    pic.Image.Dispose()
                    pic.Image = Nothing
                End If

            Else
                Dim bmp As New Bitmap(xs, ys, Imaging.PixelFormat.Format24bppRgb)
                pic.Image = bmp
                For y As Integer = 0 To ys - 1
                    For x As Integer = 0 To xs - 1
                        If (col = 8) Then
                            Dim c As Byte = data(imgFpos)
                            bmp.SetPixel(x, y, RBG8ToColor(c))
                            imgFpos += 1
                        Else
                            Dim c As UShort = (CType(data(imgFpos + 0), UShort) << 8) + CType(data(imgFpos + 1), UShort)
                            bmp.SetPixel(x, y, RBG16ToColor(c))
                            imgFpos += 2
                        End If
                    Next x
                Next y
            End If

        Next i

        '*  色モードラジオボタン設定
        If (col = 8) Then
            Me.RadioButton1.Checked = True
            Me.RadioButton2.Checked = False
        Else
            Me.RadioButton1.Checked = False
            Me.RadioButton2.Checked = True
        End If

        Return (True)

    End Function

    '*************************************************************************
    '*  メソッド
    '*             指定フォルダ内のimg999.bmpファイルを一括で読み込む
    '*  引数：String path フォルダ名
    '*  戻値：void
    '*************************************************************************
    Private Sub Load_LoadImages(ByVal path As String)

        Dim fs As System.IO.FileStream = Nothing
        Dim data As Byte() = Nothing

        '*  ピクチャボックスグリッドクリア
        For i As Integer = 0 To 255
            Dim pic As PictureBox = CType(Me.Panel1.Controls(i * 2), PictureBox)
            If (Not pic.Image Is Nothing) Then
                pic.Image.Dispose()
                pic.Image = Nothing
            End If
        Next i

        '*  フォルダ名の最後に '\' を付加
        If (path.Substring(path.Length - 1) <> "\") Then
            path &= "\"
        End If

        '*  フォルダ内を検索
        For Each bmpFname As String In System.IO.Directory.GetFiles(path, "img???.bmp")

            Dim num As String = bmpFname.Substring(bmpFname.Length - 7, 3)
            If (IsNumeric(num) <> True) Then
                Continue For
            End If

            Dim idx As Integer = Integer.Parse(num)
            If ((idx < 0) OrElse (idx > 255)) Then
                Continue For
            End If

            Using tmp As New Bitmap(bmpFname)

                Dim bmp As New Bitmap(tmp.Width, tmp.Height, Imaging.PixelFormat.Format24bppRgb)
                For y As Integer = 0 To tmp.Height - 1
                    For x As Integer = 0 To tmp.Width - 1
                        bmp.SetPixel(x, y, tmp.GetPixel(x, y))
                    Next x
                Next y

                Dim pic As PictureBox = CType(Me.Panel1.Controls(idx * 2), PictureBox)
                pic.Image = bmp

            End Using

        Next bmpFname

    End Sub

    '*************************************************************************
    '*  メソッド
    '*       ピクチャボックスグリッド内のイメージをファイルデータ化
    '*　引数：void
    '*　戻値：void
    '*************************************************************************
    Private Sub makeIconDatas()

        '*  必要なデータ領域を確保
        Dim secCount As Integer = 5                 '* ヘッダとして５セクタ
        For i As Integer = 0 To 255
            secCount += Convert(Me.Panel1.Controls(i * 2), 0, Nothing)
        Next i

        Erase Me.iconDatas
        ReDim iconDatas((secCount * 512) - 1)
        Array.Clear(iconDatas, 0, iconDatas.Length)

        '*  ヘッダ部セット
        strcpy(iconDatas, &H0, "OLED_ICONS")
        strcpy(iconDatas, &H10, Now.ToString("yyyy/MM/dd"))

        If (Me.RadioButton1.Checked = True) Then
            iconDatas(&H20) = 8
        Else
            iconDatas(&H20) = 16
        End If

        '*  データ作成
        Dim secIndex As Integer = 5
        For i As Integer = 0 To 255

            Dim pic As PictureBox = CType(Me.Panel1.Controls(i * 2), PictureBox)
            Dim bmp As Bitmap = CType(pic.Image, Bitmap)
            Dim pos As Integer = 512 + (i * 8)

            '*  インデックス番号
            iconDatas(pos + 0) = CType(i, Byte)
            iconDatas(pos + 1) = 0

            If (Not bmp Is Nothing) Then

                '*  Ｘサイズ
                iconDatas(pos + 2) = CType(bmp.Width, Byte)

                '*  Yサイズ
                iconDatas(pos + 3) = CType(bmp.Height, Byte)

                '* セクタオフセット値
                iconDatas(pos + 4) = CType((secIndex And &HFF), Byte)
                iconDatas(pos + 5) = CType(((secIndex >> 8) And &HFF), Byte)
                iconDatas(pos + 6) = CType(((secIndex >> 16) And &HFF), Byte)
                iconDatas(pos + 7) = CType(((secIndex >> 24) And &HFF), Byte)

                '*  イメージデータ作成
                secIndex += Convert(pic, secIndex, iconDatas)

            End If

        Next i

    End Sub

    '*************************************************************************
    '*  メソッド
    '*              ピクチャボックスグリッド内のアイテムを取得
    '*　引数：Integer x X座標
    '*        Integer y Y座標
    '*　戻値：void
    '*************************************************************************
    Private Function getItemPic(ByVal x As Integer, ByVal y As Integer) As PictureBox

        Dim index As Integer = ((y * Me.GridX) + x) * 2
        Return (CType(Me.Panel1.Controls(index), PictureBox))

    End Function

    '*************************************************************************
    '*  メソッド
    '*              ピクチャボックスグリッド内のアイテム位置Xを取得
    '*　引数：Integer x X座標
    '*        Integer y Y座標
    '*　戻値：void
    '*************************************************************************
    Private Function getItemX(ByVal pic As PictureBox) As Integer

        Dim Index As Integer = Me.Panel1.Controls.IndexOf(pic) \ 2
        Return (Index Mod Me.GridX)

    End Function

    '*************************************************************************
    '*  メソッド
    '*              ピクチャボックスグリッド内のアイテム位置Yを取得
    '*　引数：Integer x X座標
    '*        Integer y Y座標
    '*　戻値：void
    '*************************************************************************
    Private Function getItemY(ByVal pic As PictureBox) As Integer

        Dim Index As Integer = Me.Panel1.Controls.IndexOf(pic) \ 2
        Return (Index \ Me.GridX)

    End Function

End Class
