﻿Public Class fmOgg

    '*************************************************************************
    '*  イベント
    '*                          フォームロード
    '*************************************************************************
    Private Sub fmOgg_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    '*************************************************************************
    '*  イベント
    '*                          フォームクローズ
    '*************************************************************************
    Private Sub fmOgg_Load_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        End

    End Sub

    '*************************************************************************
    '*  イベント
    '*              メニュー「フォントファイル作成」クリック
    '*************************************************************************
    Private Sub FontToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FontToolStripMenuItem.Click
        fmFontMake.Top = Me.Top
        fmFontMake.Left = Me.Left
        fmFontMake.Show()
        Me.Hide()
    End Sub

    '*************************************************************************
    '*  イベント
    '*              メニュー「アイコンファイル作成」クリック
    '*************************************************************************
    Private Sub IconToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IconToolStripMenuItem.Click
        fmIconMake.Top = Me.Top
        fmIconMake.Left = Me.Left
        Me.Hide()
        fmIconMake.Show()
    End Sub

    '*************************************************************************
    '*  イベント
    '*                       フォームへドロップができるかチェック
    '*************************************************************************
    Private Sub fmOgg_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter

        e.Effect = DragDropEffects.None
        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            Dim fnames() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
            For i As Integer = 0 To fnames.Length - 1
                If String.Compare(System.IO.Path.GetExtension(fnames(i)), ".plg", True) <> 0 Then
                    Return
                End If
            Next i
            e.Effect = DragDropEffects.Copy
        End If

    End Sub

    '*************************************************************************
    '*  イベント
    '*                     フォームへドロップ
    '*************************************************************************
    Private Sub fmOgg_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop

        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            Dim fnames() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
            Me.ProgressBar1.Minimum = 0
            Me.ProgressBar1.Maximum = fnames.Length
            Me.ProgressBar1.Value = 0
            For i As Integer = 0 To fnames.Length - 1
                If (Me.conv(fnames(i)) <> True) Then
                    Return
                End If
                Me.ProgressBar1.Value += 1
            Next i
        End If

        MessageBox.Show("ファイルを作成しました", "", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub

    '*************************************************************************
    '*  メソッド
    '*                プラグインファイルをバイナリファイルへ変換
    '*************************************************************************
    Private Function conv(ByVal fname As String) As Boolean

        Dim sr As System.IO.StreamReader = New System.IO.StreamReader(fname, System.Text.Encoding.GetEncoding(932))
        Dim buf As String = ""
        Dim plSize As UInt16 = 0
        Dim fsize As UInt16 = 0
        Dim fbuf As Byte() = Nothing
        Dim fpos As Integer = 2

        '*  ファイル読込み
        While (sr.Peek() > -1)
            buf = sr.ReadLine()
            If (plSize = 0) Then
                Try
                    If (buf.IndexOf("#define PLUGIN_SIZE") >= 0) Then
                        plSize = Convert.ToUInt16(buf.Substring(19))
                        ReDim fbuf(12 + ((CType(plSize, Integer) * 2) - 1))
                        strcpy(fbuf, 0, "VS plugin ")
                        fbuf(10) = CType(plSize And &HFF, Byte)
                        fbuf(11) = CType(((plSize And &HFF00) >> 8), Byte)
                        fpos = 12
                    End If
                Catch ex As Exception
                    fsize = 0
                    plSize = 0
                    Exit While
                End Try

            ElseIf (buf.IndexOf("0x") >= 0) Then

                Try
                    Dim s As String() = buf.Split(",")
                    For i As Integer = 0 To s.Length - 1
                        Dim pos As Integer = s(i).IndexOf("0x")
                        If (pos >= 0) Then
                            Dim code As UInt16 = Convert.ToUInt16(s(i).Substring(pos + 2, 4), 16)
                            If (fsize < plSize) Then
                                fbuf(fpos + 0) = CType(code And &HFF, Byte)
                                fbuf(fpos + 1) = CType(((code And &HFF00) >> 8), Byte)
                                fsize += 1
                                fpos += 2
                            Else
                                fsize = 0
                                Exit While
                            End If
                        End If
                    Next i

                Catch ex As Exception
                    fsize = 0
                    plSize = 0
                    Exit While
                End Try

            End If

        End While

        sr.Close()

        If ((plSize <> fsize) OrElse (plSize = 0)) Then
            MessageBox.Show("ファイルエラー", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        End If

        '*  ファイルへ書き出し
        Try
            Dim outDir As String = System.IO.Path.GetDirectoryName(fname)
            If (outDir.Substring(outDir.Length - 1) <> "\") Then
                outDir &= "\"
            End If

            Dim outFname As String = System.IO.Path.GetFileNameWithoutExtension(fname)
            If (outFname.IndexOf("venc") <> 0) Then
                MessageBox.Show("ファイル名の先頭がvencではありません", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If
            outFname = outFname.Substring(4)

            If (outFname.Length > 8) Then
                MessageBox.Show("ファイル名長が8文字を超えます", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return (False)
            End If
            outFname &= ".vsp"

            Dim fs As New System.IO.FileStream(outDir & outFname, System.IO.FileMode.Create, System.IO.FileAccess.Write)
            fs.Write(fbuf, 0, fbuf.Length)
            fs.Close()

        Catch ex As Exception
            MessageBox.Show("ファイルエラー", "", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)

        End Try

        Return (True)

    End Function

End Class